//******************************************************
// CAPAX-Xtd Expert : Mouvement Va Et Vient d'un chariot
// V1.0 Le 14/08/2018
// CAPAX SYSTEMS by www.infoconsult.tn
//******************************************************
# define echoPin 25 // Echo Pin
# define trigPin 23 // Trigger Pin

# define LED_V 42
# define LED_O 44
# define LED_R 43

# define L293_EN 2
# define L293_IN1 3
# define L293_IN2 5

# define BP 47 // Bouton poussoir

int t_imm = 3000; // immobilisation de 3 s = 3000 ms


boolean bSens=1; // 1 : droite, 0 : gauche
boolean bBP;

float vit_us=0.0171235; // Vit_us = 346.3 m/s pour T=25°C
float dist;
int VitMot;
int V_croisiere = 160;
float d_fr = 12.0; // 12 cm

void setup() {
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  
  pinMode(LED_V,OUTPUT);
  pinMode(LED_O,OUTPUT);
  pinMode(LED_R,OUTPUT);

  pinMode(L293_EN,OUTPUT);
  pinMode(L293_IN1,OUTPUT);
  pinMode(L293_IN2,OUTPUT);
}
 
void loop() {
  if (bSens ==0) { // Gauche
    VitMot = V_croisiere;
    WriteLed(1,0,0);
    digitalWrite(L293_IN1,LOW);
    digitalWrite(L293_IN2,HIGH);
    analogWrite (L293_EN,VitMot );
    bBP = digitalRead(BP);
    while (bBP==HIGH) {
      bBP = digitalRead(BP);
    }
// sequence d'arrêt et changement de sens
    bSens =!bSens;
    VitMot = 0;
    WriteLed(0,0,1);
    analogWrite(L293_EN,VitMot);
    delay(t_imm);
  }
  else { // sens = 1 Droite
    VitMot = V_croisiere;
    WriteLed(1,0,0);
    digitalWrite(L293_IN1,HIGH);
    digitalWrite(L293_IN2,LOW);
    analogWrite (L293_EN,VitMot);
    dist = ReadDist();
    while (dist > d_fr){
      dist = ReadDist();
    }
// sequence d'arrêt et de changement de sens
    bSens= !bSens;
    VitMot = 0;
    analogWrite (L293_EN,VitMot);
    WriteLed(0,0,1);
    delay(t_imm);
  }
}

void WriteLed(int vV,int vO,int vR){
  digitalWrite(LED_V,vV);
  digitalWrite(LED_O,vO);
  digitalWrite(LED_R,vR);
}

float ReadDist() {
  unsigned long duree;
  float dist;
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  duree = pulseIn(echoPin, HIGH);
  dist = float(duree)*vit_us;
  delay(10); // Temporisation pour éviter les échos parasites
  return dist; // dist directement en cm
}

